Index: src/Potentials/Specifics/ConstantPotential.cpp
===================================================================
--- src/Potentials/Specifics/ConstantPotential.cpp	(revision d5ca1af98e88b536fe2483fab7d7d2b875452e83)
+++ src/Potentials/Specifics/ConstantPotential.cpp	(revision 67044a4c103c09d1763d0f00ce6a8943f837f6a3)
@@ -202,5 +202,5 @@
       boost::bind(&Extractors::filterArgumentsByParticleTypes,
           _1,
-          getParticleTypes());
+          boost::cref(getParticleTypes()), boost::cref(getBindingModel()));
   return returnfunction;
 }
Index: src/Potentials/Specifics/FourBodyPotential_Torsion.cpp
===================================================================
--- src/Potentials/Specifics/FourBodyPotential_Torsion.cpp	(revision d5ca1af98e88b536fe2483fab7d7d2b875452e83)
+++ src/Potentials/Specifics/FourBodyPotential_Torsion.cpp	(revision 67044a4c103c09d1763d0f00ce6a8943f837f6a3)
@@ -287,6 +287,6 @@
         boost::bind(&Extractors::filterArgumentsByParticleTypes,
             _1,
-            getParticleTypes()),
-        getParticleTypes()
+            boost::cref(getParticleTypes()), boost::cref(getBindingModel())),
+        boost::cref(getParticleTypes()), boost::cref(getBindingModel())
       );
   return returnfunction;
Index: src/Potentials/Specifics/ManyBodyPotential_Tersoff.cpp
===================================================================
--- src/Potentials/Specifics/ManyBodyPotential_Tersoff.cpp	(revision d5ca1af98e88b536fe2483fab7d7d2b875452e83)
+++ src/Potentials/Specifics/ManyBodyPotential_Tersoff.cpp	(revision 67044a4c103c09d1763d0f00ce6a8943f837f6a3)
@@ -732,5 +732,5 @@
       boost::bind(&Extractors::filterArgumentsByParticleTypes,
           _1,
-          getParticleTypes());
+          boost::cref(getParticleTypes()), boost::cref(getBindingModel()));
   return returnfunction;
 }
Index: src/Potentials/Specifics/PairPotential_Harmonic.cpp
===================================================================
--- src/Potentials/Specifics/PairPotential_Harmonic.cpp	(revision d5ca1af98e88b536fe2483fab7d7d2b875452e83)
+++ src/Potentials/Specifics/PairPotential_Harmonic.cpp	(revision 67044a4c103c09d1763d0f00ce6a8943f837f6a3)
@@ -230,5 +230,5 @@
       boost::bind(&Extractors::filterArgumentsByParticleTypes,
           _1,
-          getParticleTypes());
+          boost::cref(getParticleTypes()), boost::cref(getBindingModel()));
   return returnfunction;
 }
Index: src/Potentials/Specifics/PairPotential_LennardJones.cpp
===================================================================
--- src/Potentials/Specifics/PairPotential_LennardJones.cpp	(revision d5ca1af98e88b536fe2483fab7d7d2b875452e83)
+++ src/Potentials/Specifics/PairPotential_LennardJones.cpp	(revision 67044a4c103c09d1763d0f00ce6a8943f837f6a3)
@@ -237,5 +237,5 @@
       boost::bind(&Extractors::filterArgumentsByParticleTypes,
           _1,
-          getParticleTypes());
+          boost::cref(getParticleTypes()), boost::cref(getBindingModel()));
   return returnfunction;
 }
Index: src/Potentials/Specifics/PairPotential_Morse.cpp
===================================================================
--- src/Potentials/Specifics/PairPotential_Morse.cpp	(revision d5ca1af98e88b536fe2483fab7d7d2b875452e83)
+++ src/Potentials/Specifics/PairPotential_Morse.cpp	(revision 67044a4c103c09d1763d0f00ce6a8943f837f6a3)
@@ -256,5 +256,5 @@
       boost::bind(&Extractors::filterArgumentsByParticleTypes,
           _1,
-          getParticleTypes());
+          boost::cref(getParticleTypes()), boost::cref(getBindingModel()));
   return returnfunction;
 }
Index: src/Potentials/Specifics/ThreeBodyPotential_Angle.cpp
===================================================================
--- src/Potentials/Specifics/ThreeBodyPotential_Angle.cpp	(revision d5ca1af98e88b536fe2483fab7d7d2b875452e83)
+++ src/Potentials/Specifics/ThreeBodyPotential_Angle.cpp	(revision 67044a4c103c09d1763d0f00ce6a8943f837f6a3)
@@ -267,6 +267,6 @@
         boost::bind(&Extractors::filterArgumentsByParticleTypes,
             _1,
-            getParticleTypes()),
-        getParticleTypes()
+            boost::cref(getParticleTypes()), boost::cref(getBindingModel())),
+        boost::cref(getParticleTypes()), boost::cref(getBindingModel())
       );
   return returnfunction;