Index: tests/regression/Graph/SubgraphDissection/pre/test.conf
===================================================================
--- tests/regression/Graph/SubgraphDissection/pre/test.conf	(revision 70269a5925ba82007a722de93f0b9207048e59be)
+++ tests/regression/Graph/SubgraphDissection/pre/test.conf	(revision 70269a5925ba82007a722de93f0b9207048e59be)
@@ -0,0 +1,165 @@
+# ParallelCarParinello - main configuration file - created with molecuilder
+
+mainname	pcp	# programm name (for runtime files)
+defaultpath	not specified	# where to put files during runtime
+pseudopotpath	not specified	# where to find pseudopotentials
+
+ProcPEGamma	8	# for parallel computing: share constants
+ProcPEPsi	1	# for parallel computing: share wave functions
+DoOutVis	0	# Output data for OpenDX
+DoOutMes	1	# Output data for measurements
+DoOutOrbitals	0	# Output all Orbitals
+DoOutCurr	0	# Ouput current density for OpenDx
+DoOutNICS	0	# Output Nucleus independent current shieldings
+DoPerturbation	0	# Do perturbation calculate and determine susceptibility and shielding
+DoFullCurrent	0	# Do full perturbation
+DoConstrainedMD	0	# Do perform a constrained (>0, relating to current MD step) instead of unconstrained (0) MD
+Thermostat	Berendsen	2.5	# Which Thermostat and its parameters to use in MD case.
+CommonWannier	0	# Put virtual centers at indivual orbits, all common, merged by variance, to grid point, to cell center
+SawtoothStart	0.01	# Absolute value for smooth transition at cell border 
+VectorPlane	0	# Cut plane axis (x, y or z: 0,1,2) for two-dim current vector plot
+VectorCut	0	# Cut plane axis value
+AddGramSch	1	# Additional GramSchmidtOrtogonalization to be safe
+Seed		1	# initial value for random seed for Psi coefficients
+
+MaxOuterStep	0	# number of MolecularDynamics/Structure optimization steps
+Deltat	0.01	# time per MD step
+OutVisStep	10	# Output visual data every ...th step
+OutSrcStep	5	# Output "restart" data every ..th step
+TargetTemp	0.000950045	# Target temperature
+MaxPsiStep	0	# number of Minimisation steps per state (0 - default)
+EpsWannier	1e-07	# tolerance value for spread minimisation of orbitals
+
+# Values specifying when to stop
+MaxMinStep	100	# Maximum number of steps
+RelEpsTotalE	1e-07	# relative change in total energy
+RelEpsKineticE	1e-05	# relative change in kinetic energy
+MaxMinStopStep	0	# check every ..th steps
+MaxMinGapStopStep	0	# check every ..th steps
+
+# Values specifying when to stop for INIT, otherwise same as above
+MaxInitMinStep	100	# Maximum number of steps
+InitRelEpsTotalE	1e-05	# relative change in total energy
+InitRelEpsKineticE	0.0001	# relative change in kinetic energy
+InitMaxMinStopStep	0	# check every ..th steps
+InitMaxMinGapStopStep	0	# check every ..th steps
+
+BoxLength			# (Length of a unit cell)
+20	
+0	20	
+0	0	20	
+
+ECut		128	# energy cutoff for discretization in Hartrees
+MaxLevel	5	# number of different levels in the code, >=2
+Level0Factor	2	# factor by which node number increases from S to 0 level
+RiemannTensor	0	# (Use metric)
+PsiType		0	# 0 - doubly occupied, 1 - SpinUp,SpinDown
+MaxPsiDouble	0	# here: specifying both maximum number of SpinUp- and -Down-states
+PsiMaxNoUp	0	# here: specifying maximum number of SpinUp-states
+PsiMaxNoDown	0	# here: specifying maximum number of SpinDown-states
+AddPsis		0	# Additional unoccupied Psis for bandgap determination
+
+RCut		20	# R-cut for the ewald summation
+StructOpt	0	# Do structure optimization beforehand
+IsAngstroem	1	# 0 - Bohr, 1 - Angstroem
+RelativeCoord	0	# whether ion coordinates are relative (1) or absolute (0)
+MaxTypes	2	# maximum number of different ion types
+
+# Ion type data (PP = PseudoPotential, Z = atomic number)
+#Ion_TypeNr.	Amount	Z	RGauss	L_Max(PP)L_Loc(PP)IonMass	# chemical name, symbol
+Ion_Type1	62	1	1.0	3	3	1.00800000000	Hydrogen	H
+Ion_Type2	31	8	1.0	3	3	15.99900000000	Oxygen	O
+#Ion_TypeNr._Nr.R[0]    R[1]    R[2]    MoveType (0 MoveIon, 1 FixedIon)
+Ion_Type2_1	-3.450000000	-3.450000000	-3.954000000	0 # molecule nr 0
+Ion_Type1_1	-4.020000000	-4.220000000	-3.935000000	0 # molecule nr 1
+Ion_Type1_2	-2.897000000	-3.533000000	-3.176000000	0 # molecule nr 2
+Ion_Type2_2	-0.350000000	-3.450000000	-3.954000000	0 # molecule nr 3
+Ion_Type1_3	-1.186000000	-3.471000000	-3.486000000	0 # molecule nr 4
+Ion_Type1_4	0.283000000	-3.837000000	-3.347000000	0 # molecule nr 5
+Ion_Type2_3	2.750000000	-3.450000000	-3.954000000	0 # molecule nr 6
+Ion_Type1_5	2.181000000	-3.615000000	-4.708000000	0 # molecule nr 7
+Ion_Type1_6	3.035000000	-2.540000000	-4.054000000	0 # molecule nr 8
+Ion_Type2_4	-3.450000000	-0.350000000	-3.954000000	0 # molecule nr 9
+Ion_Type1_7	-3.429000000	0.422000000	-4.521000000	0 # molecule nr 10
+Ion_Type1_8	-3.807000000	-1.050000000	-4.503000000	0 # molecule nr 11
+Ion_Type2_5	-0.350000000	-0.350000000	-3.954000000	0 # molecule nr 12
+Ion_Type1_9	-0.570000000	-0.546000000	-3.042000000	0 # molecule nr 13
+Ion_Type1_10	0.521000000	-0.728000000	-4.084000000	0 # molecule nr 14
+Ion_Type2_6	2.750000000	-0.350000000	-3.954000000	0 # molecule nr 15
+Ion_Type1_11	2.266000000	0.237000000	-4.537000000	0 # molecule nr 16
+Ion_Type1_12	2.900000000	-1.143000000	-4.471000000	0 # molecule nr 17
+Ion_Type2_7	-3.450000000	2.750000000	-3.954000000	0 # molecule nr 18
+Ion_Type1_13	-4.166000000	2.713000000	-3.318000000	0 # molecule nr 19
+Ion_Type1_14	-2.692000000	3.058000000	-3.454000000	0 # molecule nr 20
+Ion_Type2_8	-0.350000000	2.750000000	-3.954000000	0 # molecule nr 21
+Ion_Type1_15	-0.859000000	2.027000000	-4.324000000	0 # molecule nr 22
+Ion_Type1_16	-0.772000000	3.544000000	-4.285000000	0 # molecule nr 23
+Ion_Type2_9	2.750000000	2.750000000	-3.954000000	0 # molecule nr 24
+Ion_Type1_17	2.928000000	3.649000000	-4.236000000	0 # molecule nr 25
+Ion_Type1_18	2.122000000	2.410000000	-4.593000000	0 # molecule nr 26
+Ion_Type2_10	-3.450000000	-3.450000000	-0.854000000	0 # molecule nr 27
+Ion_Type1_19	-3.851000000	-4.287000000	-1.094000000	0 # molecule nr 28
+Ion_Type1_20	-4.062000000	-3.052000000	-0.234000000	0 # molecule nr 29
+Ion_Type2_11	-0.350000000	-3.450000000	-0.854000000	0 # molecule nr 30
+Ion_Type1_21	-0.388000000	-4.167000000	-0.219000000	0 # molecule nr 31
+Ion_Type1_22	-0.224000000	-2.660000000	-0.327000000	0 # molecule nr 32
+Ion_Type2_12	2.750000000	-3.450000000	-0.854000000	0 # molecule nr 33
+Ion_Type1_23	2.734000000	-2.527000000	-0.597000000	0 # molecule nr 34
+Ion_Type1_24	2.410000000	-3.924000000	-0.093000000	0 # molecule nr 35
+Ion_Type2_13	-3.450000000	-0.350000000	-0.854000000	0 # molecule nr 36
+Ion_Type1_25	-3.665000000	0.319000000	-0.202000000	0 # molecule nr 37
+Ion_Type1_26	-3.940000000	-1.127000000	-0.581000000	0 # molecule nr 38
+Ion_Type2_14	-3.450000000	2.750000000	-0.854000000	0 # molecule nr 39
+Ion_Type1_27	-2.864000000	2.026000000	-0.631000000	0 # molecule nr 40
+Ion_Type1_28	-4.262000000	2.330000000	-1.141000000	0 # molecule nr 41
+Ion_Type2_15	2.750000000	2.750000000	-0.854000000	0 # molecule nr 42
+Ion_Type1_29	2.976000000	2.419000000	0.017000000	0 # molecule nr 43
+Ion_Type1_30	3.592000000	2.883000000	-1.293000000	0 # molecule nr 44
+Ion_Type2_16	-3.450000000	-3.450000000	2.246000000	0 # molecule nr 45
+Ion_Type1_31	-3.246000000	-2.771000000	1.601000000	0 # molecule nr 46
+Ion_Type1_32	-4.102000000	-3.053000000	2.825000000	0 # molecule nr 47
+Ion_Type2_17	-0.350000000	-3.450000000	2.246000000	0 # molecule nr 48
+Ion_Type1_33	0.034000000	-4.290000000	2.503000000	0 # molecule nr 49
+Ion_Type1_34	0.067000000	-2.803000000	2.817000000	0 # molecule nr 50
+Ion_Type2_18	2.750000000	-3.450000000	2.246000000	0 # molecule nr 51
+Ion_Type1_35	3.278000000	-2.669000000	2.418000000	0 # molecule nr 52
+Ion_Type1_36	2.248000000	-3.590000000	3.050000000	0 # molecule nr 53
+Ion_Type2_19	-3.450000000	-0.350000000	2.246000000	0 # molecule nr 54
+Ion_Type1_37	-4.009000000	-0.979000000	2.705000000	0 # molecule nr 55
+Ion_Type1_38	-2.618000000	-0.368000000	2.721000000	0 # molecule nr 56
+Ion_Type2_20	-3.450000000	2.750000000	2.246000000	0 # molecule nr 57
+Ion_Type1_39	-2.871000000	2.071000000	2.596000000	0 # molecule nr 58
+Ion_Type1_40	-3.055000000	3.005000000	1.411000000	0 # molecule nr 59
+Ion_Type2_21	-0.350000000	2.750000000	2.246000000	0 # molecule nr 60
+Ion_Type1_41	-0.895000000	2.539000000	3.005000000	0 # molecule nr 61
+Ion_Type1_42	0.474000000	3.071000000	2.615000000	0 # molecule nr 62
+Ion_Type2_22	2.750000000	2.750000000	2.246000000	0 # molecule nr 63
+Ion_Type1_43	2.127000000	2.133000000	2.633000000	0 # molecule nr 64
+Ion_Type1_44	3.614000000	2.395000000	2.461000000	0 # molecule nr 65
+Ion_Type2_23	-3.450000000	-3.450000000	5.346000000	0 # molecule nr 66
+Ion_Type1_45	-4.270000000	-3.580000000	4.868000000	0 # molecule nr 67
+Ion_Type1_46	-2.760000000	-3.612000000	4.701000000	0 # molecule nr 68
+Ion_Type2_24	-0.350000000	-3.450000000	5.346000000	0 # molecule nr 69
+Ion_Type1_47	-0.994000000	-3.755000000	5.987000000	0 # molecule nr 70
+Ion_Type1_48	0.406000000	-3.176000000	5.867000000	0 # molecule nr 71
+Ion_Type2_25	2.750000000	-3.450000000	5.346000000	0 # molecule nr 72
+Ion_Type1_49	3.193000000	-4.217000000	5.712000000	0 # molecule nr 73
+Ion_Type1_50	3.441000000	-2.795000000	5.238000000	0 # molecule nr 74
+Ion_Type2_26	-3.450000000	-0.350000000	5.346000000	0 # molecule nr 75
+Ion_Type1_51	-3.735000000	0.284000000	4.687000000	0 # molecule nr 76
+Ion_Type1_52	-2.556000000	-0.584000000	5.093000000	0 # molecule nr 77
+Ion_Type2_27	-0.350000000	-0.350000000	5.346000000	0 # molecule nr 78
+Ion_Type1_53	0.379000000	-0.556000000	5.933000000	0 # molecule nr 79
+Ion_Type1_54	-1.067000000	-0.088000000	5.926000000	0 # molecule nr 80
+Ion_Type2_28	2.750000000	-0.350000000	5.346000000	0 # molecule nr 81
+Ion_Type1_55	3.611000000	-0.524000000	5.728000000	0 # molecule nr 82
+Ion_Type1_56	2.123000000	-0.695000000	5.984000000	0 # molecule nr 83
+Ion_Type2_29	-3.450000000	2.750000000	5.346000000	0 # molecule nr 84
+Ion_Type1_57	-3.813000000	1.882000000	5.165000000	0 # molecule nr 85
+Ion_Type1_58	-2.500000000	2.638000000	5.286000000	0 # molecule nr 86
+Ion_Type2_30	-0.350000000	2.750000000	5.346000000	0 # molecule nr 87
+Ion_Type1_59	-0.250000000	3.494000000	4.751000000	0 # molecule nr 88
+Ion_Type1_60	-0.717000000	2.049000000	4.805000000	0 # molecule nr 89
+Ion_Type2_31	2.750000000	2.750000000	5.346000000	0 # molecule nr 90
+Ion_Type1_61	3.468000000	3.235000000	5.756000000	0 # molecule nr 91
+Ion_Type1_62	2.276000000	2.347000000	6.075000000	0 # molecule nr 92