Index: src/Fragmentation/Summation/Containers/FragmentationResultContainer.cpp
===================================================================
--- src/Fragmentation/Summation/Containers/FragmentationResultContainer.cpp	(revision d76d652c439e3216a6d56d8fb74dd0b915b8ca4a)
+++ src/Fragmentation/Summation/Containers/FragmentationResultContainer.cpp	(revision 99692c9432d0e1c94ff5a06b6e7bc5ac1a6c1e27)
@@ -41,5 +41,5 @@
 #include "CodePatterns/Singleton_impl.hpp"
 
-#ifdef HAVE_VMG
+#if defined(HAVE_JOBMARKET) && defined(HAVE_VMG)
 void FragmentationResultContainer::addFullResults(
     const KeySetsContainer &_keysets,
@@ -51,5 +51,5 @@
   OBSERVE;
   ASSERT( ResultsType == BothRanges,
-      "FragmentationResultContainer::getLongRangeResults() - mixing full and short range is not in the cards.");
+      "FragmentationResultContainer::addFullResults() - mixing full and short range is not in the cards.");
   ASSERT( _keysets.KeySets.size() == _forcekeysets.KeySets.size(),
       "FragmentationResultContainer::addFullResults() - keysets ("
@@ -80,5 +80,5 @@
   OBSERVE;
   ASSERT( (ResultsType == ShortRangeOnly) || (keysets.KeySets.empty()) ,
-      "FragmentationResultContainer::getLongRangeResults() - mixing full and short range is not in the cards.");
+      "FragmentationResultContainer::addFullResults() - mixing full and short range is not in the cards.");
   ASSERT( _keysets.KeySets.size() == _forcekeysets.KeySets.size(),
       "FragmentationResultContainer::addFullResults() - keysets ("
@@ -104,5 +104,5 @@
 }
 
-#ifdef HAVE_VMG
+#if defined(HAVE_JOBMARKET) && defined(HAVE_VMG)
 const FragmentationResultContainer::longrangedata_t&
 FragmentationResultContainer::getLongRangeResults() const
Index: src/Fragmentation/Summation/Containers/FragmentationResultContainer.hpp
===================================================================
--- src/Fragmentation/Summation/Containers/FragmentationResultContainer.hpp	(revision d76d652c439e3216a6d56d8fb74dd0b915b8ca4a)
+++ src/Fragmentation/Summation/Containers/FragmentationResultContainer.hpp	(revision 99692c9432d0e1c94ff5a06b6e7bc5ac1a6c1e27)
@@ -36,5 +36,5 @@
 #include "Fragmentation/Summation/Containers/MPQCData.hpp"
 #include "Fragmentation/Summation/Containers/MPQCDataMap.hpp"
-#ifdef HAVE_VMG
+#if defined(HAVE_JOBMARKET) && defined(HAVE_VMG)
 #include "Fragmentation/Summation/Containers/VMGData.hpp"
 #endif
@@ -63,10 +63,10 @@
   //!> typedef for short range data container
   typedef std::map<JobId_t, MPQCData> shortrangedata_t;
-#ifdef HAVE_VMG
+#if defined(HAVE_JOBMARKET) && defined(HAVE_VMG)
   //!> typedef for long range data container
   typedef std::map<JobId_t, VMGData> longrangedata_t;
 #endif
 
-#ifdef HAVE_VMG
+#if defined(HAVE_JOBMARKET) && defined(HAVE_VMG)
   /** Adds a a set of both short and long range results.
    *
@@ -128,5 +128,5 @@
     shortrangedata.clear();
     summedshortrange.clear();
-#ifdef HAVE_VMG
+#if defined(HAVE_JOBMARKET) && defined(HAVE_VMG)
     longrangedata.clear();
 #endif
@@ -139,5 +139,5 @@
   const shortrangedata_t& getShortRangeResults() const  { return shortrangedata; }
   const FragmentationShortRangeResults::summedshortrange_t& getShortRangeSummedResults() const  { return summedshortrange; }
-#ifdef HAVE_VMG
+#if defined(HAVE_JOBMARKET) && defined(HAVE_VMG)
   const longrangedata_t& getLongRangeResults() const;
 #endif
@@ -162,5 +162,5 @@
   FragmentationShortRangeResults::summedshortrange_t summedshortrange;
 
-#ifdef HAVE_VMG
+#if defined(HAVE_JOBMARKET) && defined(HAVE_VMG)
   //!> container for all long-range results
   std::map<JobId_t, VMGData> longrangedata;
@@ -181,5 +181,5 @@
     if (version > 1)
       ar & summedshortrange;
-#ifdef HAVE_VMG
+#if defined(HAVE_JOBMARKET) && defined(HAVE_VMG)
     ar & longrangedata;
 #endif
@@ -196,5 +196,5 @@
     if (version > 1)
       ar & summedshortrange;
-#ifdef HAVE_VMG
+#if defined(HAVE_JOBMARKET) && defined(HAVE_VMG)
     ar & longrangedata;
 #endif
Index: src/Fragmentation/Summation/Containers/Makefile.am
===================================================================
--- src/Fragmentation/Summation/Containers/Makefile.am	(revision d76d652c439e3216a6d56d8fb74dd0b915b8ca4a)
+++ src/Fragmentation/Summation/Containers/Makefile.am	(revision 99692c9432d0e1c94ff5a06b6e7bc5ac1a6c1e27)
@@ -5,12 +5,14 @@
 	Fragmentation/Summation/Containers/createMatrixNrLookup.cpp \
 	Fragmentation/Summation/Containers/FragmentationChargeDensity.cpp \
-	Fragmentation/Summation/Containers/FragmentationLongRangeResults.cpp \
 	Fragmentation/Summation/Containers/FragmentationResultContainer.cpp \
 	Fragmentation/Summation/Containers/FragmentationShortRangeResults.cpp \
 	Fragmentation/Summation/Containers/MPQCData.cpp
-	
+
+if CONDJOBMARKET	
 if CONDVMG
 FRAGMENTATIONCONTAINERSOURCE += \
+	Fragmentation/Summation/Containers/FragmentationLongRangeResults.cpp \
 	Fragmentation/Summation/Containers/VMGData.cpp
+endif
 endif
 
@@ -19,5 +21,4 @@
 	Fragmentation/Summation/Containers/extractJobIds.hpp \
 	Fragmentation/Summation/Containers/FragmentationChargeDensity.hpp \
-	Fragmentation/Summation/Containers/FragmentationLongRangeResults.hpp \
 	Fragmentation/Summation/Containers/FragmentationResultContainer.hpp \
 	Fragmentation/Summation/Containers/FragmentationShortRangeResults.hpp \
@@ -26,11 +27,14 @@
 	Fragmentation/Summation/Containers/MPQCDataMap.hpp \
 	Fragmentation/Summation/Containers/MPQCData_printKeyNames.hpp
-	
+
+if CONDJOBMARKET	
 if CONDVMG
 FRAGMENTATIONCONTAINERHEADER += \
+	Fragmentation/Summation/Containers/FragmentationLongRangeResults.hpp \
 	Fragmentation/Summation/Containers/VMGData.hpp \
 	Fragmentation/Summation/Containers/VMGDataFused.hpp \
 	Fragmentation/Summation/Containers/VMGDataMap.hpp \
 	Fragmentation/Summation/Containers/VMGData_printKeyNames.hpp
+endif
 endif
 