Index: src/Actions/AnalysisAction/DipoleAngularCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/DipoleAngularCorrelationAction.cpp	(revision 360c8bbc74f8b9ba85e29afb3769876f4b7fd8b1)
+++ src/Actions/AnalysisAction/DipoleAngularCorrelationAction.cpp	(revision 208237bbbc57a8a1a39e9eba2b8f9ccd181228d8)
@@ -9,5 +9,5 @@
  * DipoleAngularCorrelationAction.cpp
  *
- *  Created on: May 9, 2010
+ *  Created on: Feb 11, 2011
  *      Author: heber
  */
@@ -23,5 +23,4 @@
 #include "Tesselation/boundary.hpp"
 #include "linkedcell.hpp"
-#include "CodePatterns/Verbose.hpp"
 #include "CodePatterns/Log.hpp"
 #include "Element/element.hpp"
@@ -58,5 +57,5 @@
   DipoleAngularCorrelationMap *correlationmap = NULL;
   std::vector<molecule*> molecules = World::getInstance().getSelectedMolecules();
-  DoLog(0) && (Log() << Verbose(0) << "There are " << molecules.size() << " selected molecules." << std::endl);
+  LOG(0, "STATUS: There are " << molecules.size() << " selected molecules.");
   ASSERT(!params.periodic, "AnalysisDipoleAngularCorrelationAction() - periodic case not implemented.");
   correlationmap = DipoleAngularCorrelation(molecules);
Index: src/Actions/AnalysisAction/DipoleAngularCorrelationAction.def
===================================================================
--- src/Actions/AnalysisAction/DipoleAngularCorrelationAction.def	(revision 360c8bbc74f8b9ba85e29afb3769876f4b7fd8b1)
+++ src/Actions/AnalysisAction/DipoleAngularCorrelationAction.def	(revision 208237bbbc57a8a1a39e9eba2b8f9ccd181228d8)
@@ -2,5 +2,5 @@
  * DipoleAngularCorrelationAction.def
  *
- *  Created on: Aug 25, 2010
+ *  Created on: Feb 11, 2011
  *      Author: heber
  */
@@ -24,5 +24,5 @@
 #define MENUPOSITION 3
 #define ACTIONNAME DipoleAngularCorrelation
-#define TOKEN "dipole-correlation"
+#define TOKEN "dipole-angular-correlation"
 
 // finally the information stored in the ActionTrait specialization
Index: src/Actions/AnalysisAction/DipoleAngularCorrelationAction.hpp
===================================================================
--- src/Actions/AnalysisAction/DipoleAngularCorrelationAction.hpp	(revision 360c8bbc74f8b9ba85e29afb3769876f4b7fd8b1)
+++ src/Actions/AnalysisAction/DipoleAngularCorrelationAction.hpp	(revision 208237bbbc57a8a1a39e9eba2b8f9ccd181228d8)
@@ -2,5 +2,5 @@
  * DipoleAngularCorrelationAction.hpp
  *
- *  Created on: May 9, 2010
+ *  Created on: Feb 11, 2011
  *      Author: heber
  */
Index: src/Actions/AnalysisAction/DipoleCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/DipoleCorrelationAction.cpp	(revision 208237bbbc57a8a1a39e9eba2b8f9ccd181228d8)
+++ src/Actions/AnalysisAction/DipoleCorrelationAction.cpp	(revision 208237bbbc57a8a1a39e9eba2b8f9ccd181228d8)
@@ -0,0 +1,86 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * DipoleCorrelationAction.cpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Analysis/analysis_correlation.hpp"
+#include "CodePatterns/Log.hpp"
+#include "Element/element.hpp"
+#include "Element/periodentafel.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "linkedcell.hpp"
+#include "molecule.hpp"
+#include "World.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace MoleCuilder;
+
+#include "Actions/AnalysisAction/DipoleCorrelationAction.hpp"
+
+// and construct the stuff
+#include "DipoleCorrelationAction.def"
+#include "Action_impl_pre.hpp"
+
+/** =========== define the function ====================== */
+Action::state_ptr AnalysisDipoleCorrelationAction::performCall() {
+  //int ranges[3] = {1, 1, 1};
+  ofstream output;
+  ofstream binoutput;
+  string type;
+  BinPairMap *binmap = NULL;
+
+  // obtain information
+  getParametersfromValueStorage();
+
+  // execute action
+  output.open(params.outputname.string().c_str());
+  binoutput.open(params.binoutputname.string().c_str());
+  DipoleCorrelationMap *correlationmap = NULL;
+  std::vector<molecule*> molecules = World::getInstance().getSelectedMolecules();
+  LOG(0, "STATUS: There are " << molecules.size() << " selected molecules.");
+  ASSERT(!params.periodic, "AnalysisDipoleCorrelationAction() - periodic case not implemented.");
+  correlationmap = DipoleCorrelation(molecules);
+  OutputCorrelationMap<DipoleCorrelationMap>(&output, correlationmap, OutputDipoleCorrelation_Header, OutputDipoleCorrelation_Value);
+  binmap = BinData( correlationmap, params.BinWidth, params.BinStart, params.BinEnd );
+  OutputCorrelationMap<BinPairMap> ( &binoutput, binmap, OutputCorrelation_Header, OutputCorrelation_Value );
+  delete(binmap);
+  delete(correlationmap);
+  output.close();
+  binoutput.close();
+  return Action::success;
+}
+
+Action::state_ptr AnalysisDipoleCorrelationAction::performUndo(Action::state_ptr _state) {
+  return Action::success;
+}
+
+Action::state_ptr AnalysisDipoleCorrelationAction::performRedo(Action::state_ptr _state){
+  return Action::success;
+}
+
+bool AnalysisDipoleCorrelationAction::canUndo() {
+  return true;
+}
+
+bool AnalysisDipoleCorrelationAction::shouldUndo() {
+  return true;
+}
+/** =========== end of function ====================== */
Index: src/Actions/AnalysisAction/DipoleCorrelationAction.def
===================================================================
--- src/Actions/AnalysisAction/DipoleCorrelationAction.def	(revision 208237bbbc57a8a1a39e9eba2b8f9ccd181228d8)
+++ src/Actions/AnalysisAction/DipoleCorrelationAction.def	(revision 208237bbbc57a8a1a39e9eba2b8f9ccd181228d8)
@@ -0,0 +1,30 @@
+/*
+ * DipoleCorrelationAction.def
+ *
+ *  Created on: Aug 25, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include <string>
+#include <vector>
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required, use (NODEFAULT) for each (undefined) default value
+#define paramtypes (double)(double)(double)(boost::filesystem::path)(boost::filesystem::path)(bool)
+#define paramreferences (BinStart)(BinWidth)(BinEnd)(outputname)(binoutputname)(periodic)
+#define paramtokens ("bin-start")("bin-width")("bin-end")("output-file")("bin-output-file")("periodic")
+#define paramdescriptions ("start of the first bin")("width of the bins")("start of the last bin")("name of the output file")("name of the bin output file")("system is constraint to periodic boundary conditions")
+#define paramdefaults (NODEFAULT)("0.5")(NODEFAULT)(NODEFAULT)(NODEFAULT)("0")
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Analysis
+#define MENUNAME "analysis"
+#define MENUPOSITION 3
+#define ACTIONNAME DipoleCorrelation
+#define TOKEN "dipole-correlation"
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "dipole orientation correlation analysis between molecules"
+#undef SHORTFORM
Index: src/Actions/AnalysisAction/DipoleCorrelationAction.hpp
===================================================================
--- src/Actions/AnalysisAction/DipoleCorrelationAction.hpp	(revision 208237bbbc57a8a1a39e9eba2b8f9ccd181228d8)
+++ src/Actions/AnalysisAction/DipoleCorrelationAction.hpp	(revision 208237bbbc57a8a1a39e9eba2b8f9ccd181228d8)
@@ -0,0 +1,21 @@
+/*
+ * DipoleCorrelationAction.hpp
+ *
+ *  Created on: May 9, 2010
+ *      Author: heber
+ */
+
+#ifndef DIPOLECORRELATIONACTION_HPP_
+#define DIPOLECORRELATIONACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Actions/Action.hpp"
+
+#include "DipoleCorrelationAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* DIPOLECORRELATIONACTION_HPP_ */
Index: src/Actions/Makefile.am
===================================================================
--- src/Actions/Makefile.am	(revision 360c8bbc74f8b9ba85e29afb3769876f4b7fd8b1)
+++ src/Actions/Makefile.am	(revision 208237bbbc57a8a1a39e9eba2b8f9ccd181228d8)
@@ -88,4 +88,5 @@
 ANALYSISACTIONSOURCE = \
   Actions/AnalysisAction/DipoleAngularCorrelationAction.cpp \
+  Actions/AnalysisAction/DipoleCorrelationAction.cpp \
   Actions/AnalysisAction/MolecularVolumeAction.cpp \
   Actions/AnalysisAction/PairCorrelationAction.cpp \
@@ -95,4 +96,5 @@
 ANALYSISACTIONHEADER = \
   Actions/AnalysisAction/DipoleAngularCorrelationAction.hpp \
+  Actions/AnalysisAction/DipoleCorrelationAction.hpp \
   Actions/AnalysisAction/MolecularVolumeAction.hpp \
   Actions/AnalysisAction/PairCorrelationAction.hpp \
@@ -102,4 +104,5 @@
 ANALYSISACTIONDEFS = \
   Actions/AnalysisAction/DipoleAngularCorrelationAction.def \
+  Actions/AnalysisAction/DipoleCorrelationAction.def \
   Actions/AnalysisAction/MolecularVolumeAction.def \
   Actions/AnalysisAction/PairCorrelationAction.def \